program xyz(input,output, dat, out); {$M 65520, 0, 0}

const
   showall = false;
      (* true  ==> show all solutions             *)
      (* false ==> show only first solution found *)

type
   hexagon = array[ 0..5 ] of char;
   puzzle = array[ 0..6 ] of record
      num : integer;
      hex : hexagon
      end;

var
   dat, out : text;
   stack : array[ 1..6 ] of integer;
   stackptr : integer;
   tmp: integer;

{ add turbo-stuff }
procedure inc( var i:integer );
begin
    i := i + 1;
end;

procedure dec( var i:integer );
begin
    i := i - 1;
end;
(* = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = *)

procedure push( n : integer );

   begin
   inc( stackptr );
   stack[ stackptr ] := n
   end;

(* = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = *)

function pop : integer;

   begin
   pop := stack[ stackptr ];
   dec( stackptr )
   end;

(* = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = *)

procedure readpuzzle( var p : puzzle );

   var
      i, j : integer;

   begin
   for i := 0 to 6 do
      begin
      p[ i ].num := i;
      for j := 0 to 5 do read( dat, p[ i ].hex[ j ] );
      readln( dat )
      end;
   readln( dat )
   end;

(* = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = *)

procedure showsolution( s : puzzle );

   procedure outputhex( h : hexagon; t : integer );

      var
         i : integer;

      begin
      for i := 0 to 5 do write( out, h[ (t + i) mod 6 ] )
      end;

   var
      i, t : integer;

   begin
   writeln( out );
   writeln( out, 'PEG  HEX  POSITION' );
   writeln( out, '---  ---  --------' );
   write( out, 0:2, '':4, chr( 65 + s[ 0 ].num ), '    ' );
   outputhex( s[ 0 ].hex, 0 );
   writeln( out );
   for i := 1 to 6 do
      begin
      write( out, i:2, '':4, chr( 65 + s[ i ].num ), '    ' );
      outputhex( s[ i ].hex, (stack[ i ] + (10 - i) mod 6) mod 6 );
      writeln( out )
      end
   end;

(* = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = *)

function solvable( p, s : puzzle; n : integer ) : boolean;

   var
      i, j : integer;

   begin
   solvable := false;
   for i := 0 to 6 do
      if p[ i ].num <> -1 then
         begin
         s[ n ] := p[ i ];
         p[ i ].num := -1;
         if n = 0 then
            begin
            if solvable( p, s, 1 ) then
               begin
               solvable := true;
               {!!if not showall then exit }
               end
            end
         else if n = 1 then
            begin
            for j := 0 to 5 do
               if s[ 1 ].hex[ j ] = s[ 0 ].hex[ 0 ] then
                  begin
                  push( j );
                  if solvable( p, s, 2 ) then
                     begin
                     solvable := true;
                     {!! if not showall then exit }
                     end;
                  tmp := pop
                  end
            end
         else
            begin
            for j := 0 to 5 do
               if (s[ n ].hex[ j ] = s[ 0 ].hex[ n - 1 ])
               and (s[ n ].hex[ (j + 1) mod 6 ] = s[ n - 1 ].hex[ (stack[ n - 1 ] + 5) mod 6 ]) then
                  begin
                  if n = 6 then
                     begin
                     if s[ 6 ].hex[ (j + 5) mod 6 ] = s[ 1 ].hex[ (stack[ 1 ] + 1) mod 6 ] then
                        begin
                        push( j );
                        showsolution( s );
                        solvable := true;
                        {!! if not showall then exit else } tmp := pop 
                        end
                     end
                  else
                     begin
                     push( j );
                     if solvable( p, s, n + 1 ) then
                        begin
                        solvable := true;
                        {!! if not showall then exit }
                        end;
                     tmp := pop
                     end
                  end
            end;
         p[ i ].num := i
         end
   end;

(* = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = *)

procedure solve( pieces : puzzle );

   var
      solution : puzzle;

   begin
   stackptr := 0;
   if not solvable( pieces, solution, 0 ) then
      writeln( out, 'No solutions possible' );
   end;

(* = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = *)

var
   pieces : puzzle;

begin
{ assign( dat, 'hexagons.in' ); }
{ assign( out, 'hexagons.out' ); }
{ reset( dat ); }
{ rewrite( out ); }
reset( dat, 'hexagons.in' );
rewrite( out, 'hexagons.out' );
while not eof( dat ) do
   begin
   readpuzzle( pieces );
   solve( pieces );
   writeln( out );
   writeln( out, '************************************' )
   end;
close( out );
close( dat )
end.
